function Get-ApplicationCustomMigration {
    param(
      [string]$pathProduct = "$($settings.product_path)",
      [string]$migration_edges_path = "$($settings.migration_edges_path)",
      [bool]$consinco,
      [string]$instance_type,
      [string]$application_type
    )
  
    if ($consinco) {

      if ($instance_type -eq "core_instance"){

        if ($(Test-Path -Path "$pathProduct") -and $($application_type -eq "c5client_core")) {
          try {
            Compress-Archive -Path "$pathProduct\*" -DestinationPath "$migration_edges_path\c5client_core.zip" -CompressionLevel Optimal -Force | Out-Null
          }
          catch {
          }
        }

        if ($(Test-Path -Path "$pathProduct") -and $($application_type -eq "inetpub_core_bkp")) {
          try {
            Compress-Archive -Path "$pathProduct\*" -DestinationPath "$migration_edges_path\inetpub_core_bkp.zip" -CompressionLevel Optimal -Force | Out-Null
          }
          catch {
          }
        }

        if ($(Test-Path -Path "$pathProduct") -and $($application_type -eq "inetpub_core_totvs")) {
          try {
            Compress-Archive -Path "$pathProduct\*" -DestinationPath "$migration_edges_path\inetpub_core_totvs.zip" -CompressionLevel Optimal -Force | Out-Null
          }
          catch {
          }
        }
      }

      if ($instance_type -eq "desktop_instance"){

        if ($(Test-Path -Path "$pathProduct") -and $($application_type -eq "c5client_desktop")) {
          try {
            Compress-Archive -Path "$pathProduct\*" -DestinationPath "$migration_edges_path\c5client_desktop.zip" -CompressionLevel Optimal -Force | Out-Null
          }
          catch {
          }
        }
      }

      if ($instance_type -eq "pdv_instance"){

        if ($(Test-Path -Path "$pathProduct") -and $($application_type -eq "c5client_pdv")) {
          try {
            7z a "$migration_edges_path\c5client_pdv.zip" -tzip "$pathProduct\*"
          }
          catch {
          }
        }
      }
      
      return "sucesso"

    }
  }