﻿#Load required libraries
Add-Type -AssemblyName PresentationFramework, PresentationCore, WindowsBase, System.Windows.Forms, System.Drawing 
$scriptDir = if (-not $PSScriptRoot) { Split-Path -Parent (Convert-Path ([environment]::GetCommandLineArgs()[0])) } else { $PSScriptRoot }

[xml]$xaml = @"
<Window 
    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
    xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
    xmlns:local="clr-namespace:WpfApp7"
    
    ResizeMode="CanMinimize"
    Title="Migrador Consinco - TCLOUD" Height="520" Width="1020" Icon="$scriptDir\Resources\favicon.ico">
    
    <Window.Resources>
        <ResourceDictionary>
            <ResourceDictionary.MergedDictionaries>
                <ResourceDictionary Source="$scriptDir\Resources\Metro.MSControls.Core.Implicit.xaml"/>
                <ResourceDictionary Source="$scriptDir\Resources\Styles.WPF.xaml"/>
                <ResourceDictionary Source="$scriptDir\Resources\Theme.Colors.xaml"/>
                <ResourceDictionary Source="$scriptDir\Resources\Styles.Shared.xaml"/>
            </ResourceDictionary.MergedDictionaries>

            <Style TargetType="{x:Type Label}">
                <Setter Property="Foreground" Value="Black"/>
                <Setter Property="FontSize" Value="13"/>
                <Setter Property="VerticalContentAlignment" Value="Center"/>
                <Setter Property="HorizontalContentAlignment" Value="Center"/>
            </Style>
        </ResourceDictionary>
    </Window.Resources>

    <Grid Margin="0,-28,0,28">
        
        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="Informe o(s) diretório(s) referente(s) a instalação do Consinco Core:" Margin="3,40,0,0"/>
            
        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="Diretório C5Client Core:" Margin="3,70,0,0"/>
        <TextBox Name="textBoxCoreDirC5Client" HorizontalAlignment="Left" VerticalAlignment="Top" Height="30" Width="670" TextWrapping="Wrap" Margin="290,70,0,0"/>
        <Button Name="btnCoreDirC5Client" Content="..." HorizontalAlignment="Left" VerticalAlignment="Top" Width="10" Margin="950,70,0,0"/>

        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="Diretório Backups Core:" Margin="3,105,0,0"/>
        <TextBox Name="textBoxCoreDirBackups" HorizontalAlignment="Left" VerticalAlignment="Top" Height="30" Width="670" TextWrapping="Wrap" Margin="290,105,0,0"/>
        <Button Name="btnCoreDirBackups" Content="..." HorizontalAlignment="Left" VerticalAlignment="Top" Width="10" Margin="950,105,0,0"/>

        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="Diretório TOTVS_Varejo_Supermercados:" Margin="3,140,0,0"/>
        <TextBox Name="textBoxCoreDirTOTVS_Varejo_Supermercados" HorizontalAlignment="Left" VerticalAlignment="Top" Height="30" Width="670" TextWrapping="Wrap" Margin="290,140,0,0"/>
        <Button Name="btnCoreDirTOTVS_Varejo_Supermercados" Content="..." HorizontalAlignment="Left" VerticalAlignment="Top" Width="10" Margin="950,140,0,0"/>

        <Rectangle VerticalAlignment="Top"  HorizontalAlignment="Stretch" Fill="Black" Height="2" Margin="0,185,0,0"/>

        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="Informe o(s) diretório(s) referente(s) a instalação do Consinco Desktop:" Margin="3,190,0,0"/>

        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="Diretório C5Client Desktop:" Margin="3,225,0,0"/>
        <TextBox Name="textBoxDesktopDirC5Client" HorizontalAlignment="Left" VerticalAlignment="Top" Height="30" Width="670" TextWrapping="Wrap" Margin="290,225,0,0"/>
        <Button Name="btnDesktopDirC5Client" Content="..." HorizontalAlignment="Left" VerticalAlignment="Top" Width="10" Margin="950,225,0,0"/>
        
        <Rectangle VerticalAlignment="Top"  HorizontalAlignment="Stretch" Fill="Black" Height="2" Margin="0,270,0,0"/>
        
        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="Informe o(s) diretório(s) referente(s) a instalação do Consinco PDV:" Margin="3,275,0,0"/>
        
        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="Diretório C5Client PDV:" Margin="3,310,0,0"/>
        <TextBox Name="textBoxPDVDirC5Client" HorizontalAlignment="Left" VerticalAlignment="Top" Height="30" Width="670" TextWrapping="Wrap" Margin="290,310,0,0"/>
        <Button Name="btnPDVDirC5Client" Content="..." HorizontalAlignment="Left" VerticalAlignment="Top" Width="10" Margin="950,310,0,0"/>

        <Rectangle VerticalAlignment="Top"  HorizontalAlignment="Stretch" Fill="Black" Height="2" Margin="0,355,0,0"/>

        <Label HorizontalAlignment="Left" VerticalAlignment="Top" Content="PASTA DE DESTINO:" Margin="3,375,0,0"/>
        <TextBox Name="textBoxDestino" HorizontalAlignment="Left" VerticalAlignment="Top" Height="30" Width="670" TextWrapping="Wrap" Margin="290,375,0,0"/>
        <Button Name="btnDestino" Content="..." HorizontalAlignment="Left" VerticalAlignment="Top" Width="10" Margin="950,375,0,0"/>

        <Rectangle VerticalAlignment="Top"  HorizontalAlignment="Stretch" Fill="Black" Height="2" Margin="0,430,0,0"/>
        
        <Button Name="btnLimpar" Content="Limpar" HorizontalAlignment="Left" VerticalAlignment="Top" Width="75" Margin="720,450,0,0"/>
        <Button Name="btnCancel" Content="Cancelar" HorizontalAlignment="Left" VerticalAlignment="Top" Width="75" Margin="800,450,0,0"/>
        <Button Name="btnExport" Content="Exportar" HorizontalAlignment="Left" VerticalAlignment="Top" Width="75" Margin="905,450,0,0"/>
    
    </Grid>
</Window>
"@

#Read the form
$Reader = (New-Object System.Xml.XmlNodeReader $xaml) 
$Form = [Windows.Markup.XamlReader]::Load($reader) 

#AutoFind all controls
$xaml.SelectNodes("//*[@*[contains(translate(name(.),'n','N'),'Name')]]")  | ForEach-Object { 
  New-Variable  -Name $_.Name -Value $Form.FindName($_.Name) -Force 
}

# Load functions
Import-Module "$scriptDir\Helpers\ExportConsincoFiles.psm1" -Force
. "$scriptDir\Helpers\OpenBrowserDialog.ps1"
. "$scriptDir\Helpers\New-WPFMessageBox.ps1"

#Make the mouse act like something is happening
$btnExport.Add_MouseEnter({
    $Form.Cursor = [System.Windows.Input.Cursors]::Hand
})
#Switch back to regular mouse
$btnExport.Add_MouseLeave({
    $Form.Cursor = [System.Windows.Input.Cursors]::Arrow
})


$btnCoreDirC5Client.Add_Click({
    $folderSelected = Get-FolderName "C:\" -Description "Selecione um diretório"
    if(!([string]::IsNullOrEmpty($folderSelected))){
        $textBoxCoreDirC5Client.Text = "$folderSelected"
    }
})
$btnCoreDirBackups.Add_Click({
    $folderSelected = Get-FolderName "C:\" -Description "Selecione um diretório"
    if(!([string]::IsNullOrEmpty($folderSelected))){
        $textBoxCoreDirBackups.Text = "$folderSelected"
    }
})
$btnCoreDirTOTVS_Varejo_Supermercados.Add_Click({
    $folderSelected = Get-FolderName "C:\" -Description "Selecione um diretório"
    if(!([string]::IsNullOrEmpty($folderSelected))){
        $textBoxCoreDirTOTVS_Varejo_Supermercados.Text = "$folderSelected"
    }
})

$btnDesktopDirC5Client.Add_Click({
    $folderSelected = Get-FolderName "C:\" -Description "Selecione um diretório"
    if(!([string]::IsNullOrEmpty($folderSelected))){
        $textBoxDesktopDirC5Client.Text = "$folderSelected"
    }
})

$btnPDVDirC5Client.Add_Click({
    $folderSelected = Get-FolderName "C:\" -Description "Selecione um diretório"
    if(!([string]::IsNullOrEmpty($folderSelected))){
        $textBoxPDVDirC5Client.Text = "$folderSelected"
    }
})

$btnDestino.Add_Click({
    $folderSelected = Get-FolderName "C:\" -Description "Selecione um diretório"
    if(!([string]::IsNullOrEmpty($folderSelected))){
        $textBoxDestino.Text = "$folderSelected"
    }
})

# Add event for click mouse on button EXPORT for generate files in folder destination
$btnExport.Add_Click({
    try{
        $Form.Cursor = [System.Windows.Input.Cursors]::Wait

        #verifica se foi preenchido pelo menos algum campo de origem
        if([string]::IsNullOrEmpty($textBoxCoreDirC5Client.Text) -and [string]::IsNullOrEmpty($textBoxCoreDirBackups.Text) -and [string]::IsNullOrEmpty($textBoxCoreDirTOTVS_Varejo_Supermercados.Text) -and [string]::IsNullOrEmpty($textBoxDesktopDirC5Client.Text) -and [string]::IsNullOrEmpty($textBoxPDVDirC5Client.Text)){
            New-WPFMessageBox @InfoParams -Content "Deve ser preenchido algum campo de origem."
            return
        }

        #verifica se foi preenchido campo de destino
        if(!([string]::IsNullOrEmpty($textBoxDestino.Text))){

            try {
                Write-Log "Limpa pasta $migration_edges_path"
                Get-ChildItem -Path $migration_edges_path -Include *.* -File -Recurse | foreach { $_.Delete()}
            }
            catch {
            }

            if(!([string]::IsNullOrEmpty($textBoxCoreDirC5Client.Text))){
                $result = Get-ApplicationCustomMigration $textBoxCoreDirC5Client.Text $textBoxDestino.Text $true "core_instance" "c5client_core"  
            }
            if(!([string]::IsNullOrEmpty($textBoxCoreDirBackups.Text))){
                $result = Get-ApplicationCustomMigration $textBoxCoreDirBackups.Text $textBoxDestino.Text $true "core_instance" "inetpub_core_bkp"  
            }
            if(!([string]::IsNullOrEmpty($textBoxCoreDirTOTVS_Varejo_Supermercados.Text))){
                $result = Get-ApplicationCustomMigration $textBoxCoreDirTOTVS_Varejo_Supermercados.Text $textBoxDestino.Text $true "core_instance" "inetpub_core_totvs"  
            }
            if(!([string]::IsNullOrEmpty($textBoxDesktopDirC5Client.Text))){
                $result = Get-ApplicationCustomMigration $textBoxDesktopDirC5Client.Text $textBoxDestino.Text $true "desktop_instance" "c5client_desktop"  
            }
            if(!([string]::IsNullOrEmpty($textBoxPDVDirC5Client.Text))){
                $result = Get-ApplicationCustomMigration $textBoxPDVDirC5Client.Text $textBoxDestino.Text $true "pdv_instance" "c5client_pdv"  
            }
        }
        else{
            New-WPFMessageBox @InfoParams -Content "Campo destino é obrigatório."
            return
        }

        if($result -eq "sucesso"){
                # Dialog for result success
            $InfoParams = @{
                Title = "RESULTADO DA EXPORTAÇÃO"
                TitleFontSize = 20
                TitleBackground = 'LightSkyBlue'
                TitleTextForeground = 'Black'
            }
            New-WPFMessageBox @InfoParams -Content "Exportação realizada com sucesso para o diretório $($textBoxDestino.Text)."

        } else {      
            # Dialog for result error
            $ErrorMsgParams = @{
                Title = "RESULTADO DA EXPORTAÇÃO"
                TitleBackground = "Red"
                TitleTextForeground = "WhiteSmoke"
                TitleFontWeight = "UltraBold"
                TitleFontSize = 20
                Sound = 'Windows Exclamation'
            }
            New-WPFMessageBox @ErrorMsgParams -Content "Ocorreu um erro na exportação. Por favor, tente novamente mais tarde ou entre em contato com o atendimento Totvs Cloud para a Linha Consinco."
            return
        }

        $Form.Cursor = [System.Windows.Input.Cursors]::Default
    } catch {
        # Dialog for result error
        $ErrorMsgParams = @{
            Title = "RESULTADO DA EXPORTAÇÃO"
            TitleBackground = "Red"
            TitleTextForeground = "WhiteSmoke"
            TitleFontWeight = "UltraBold"
            TitleFontSize = 20
            Sound = 'Windows Exclamation'
        }
        New-WPFMessageBox @ErrorMsgParams -Content "Ocorreu um erro na exportação. Por favor, tente novamente mais tarde ou entre em contato com o atendimento Totvs Cloud para a Linha Consinco."
    }   
})

#Make the mouse act like something is happening
$btnCancel.Add_MouseEnter({
    $Form.Cursor = [System.Windows.Input.Cursors]::Hand
})
#Switch back to regular mouse
$btnCancel.Add_MouseLeave({
    $Form.Cursor = [System.Windows.Input.Cursors]::Arrow
})
# Add event for click mouse on button EXPORT for generate files in folder destination
$btnCancel.Add_Click({
    Exit 0
})

#Make the mouse act like something is happening
$btnLimpar.Add_MouseEnter({
    $Form.Cursor = [System.Windows.Input.Cursors]::Hand
})
#Switch back to regular mouse
$btnLimpar.Add_MouseLeave({
    $Form.Cursor = [System.Windows.Input.Cursors]::Arrow
})
# Add event for click mouse on button EXPORT for generate files in folder destination
$btnLimpar.Add_Click({
    $textBoxCoreDirC5Client.Text = ""
    $textBoxCoreDirBackups.Text = ""
    $textBoxCoreDirTOTVS_Varejo_Supermercados.Text = ""
    $textBoxDesktopDirC5Client.Text = ""
    $textBoxPDVDirC5Client.Text = ""
    $textBoxDestino.Text = ""
})

#Mandetory last line of every script to load form
$Form.ShowDialog() | Out-Null